"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ImplementationError extends Error {
    constructor(message) {
        super(message);
        // see: typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html
        Object.setPrototypeOf(this, new.target.prototype); // restore prototype chain
        this.name = ImplementationError.name; // stack traces display correctly now
    }
}
exports.ImplementationError = ImplementationError;
class TodoError extends Error {
    constructor(message) {
        super(message);
        // see: typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html
        Object.setPrototypeOf(this, new.target.prototype); // restore prototype chain
        this.name = TodoError.name; // stack traces display correctly now
    }
}
exports.TodoError = TodoError;
class SyntaxError {
}
exports.SyntaxError = SyntaxError;
class TypeError {
    constructor(message, loc) {
        this.name = "TypeError";
        this.message = message;
        this.location = loc;
    }
}
exports.TypeError = TypeError;
class ImportError {
    constructor(message, loc, path) {
        this.message = message;
        this.location = loc;
        this.path = path;
    }
}
exports.ImportError = ImportError;
//# sourceMappingURL=errors.js.map