"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("../errors");
const Type_1 = require("./Type");
/**
 * ArrayLiteralTypes are created while parsing and are then unified.
 * They are gone after type checking.
 */
class ArrayLiteralType extends Type_1.Type {
    constructor(types) {
        super();
        this.types = types;
    }
    toString() {
        let name = "literal[";
        for (let t of this.types) {
            if (name == "literal[") {
                name += t.toString();
            }
            else {
                name += "," + t.toString();
            }
        }
        name += "]";
        return name;
    }
    toTypeCodeString() {
        throw new errors_1.ImplementationError();
    }
}
exports.ArrayLiteralType = ArrayLiteralType;
//# sourceMappingURL=ArrayLiteralType.js.map