"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
class ArrayType extends Type_1.Type {
    constructor(elementType, size) {
        super();
        this.elementType = elementType;
        this.size = size;
    }
    getElementType() {
        return this.elementType;
    }
    toString() {
        if (this.name) {
            return this.name;
        }
        if (this.size === null) {
            return "[...]" + this.elementType.toString();
        }
        return "[" + this.size.toString() + "]" + this.elementType.toString();
    }
    toTypeCodeString() {
        if (this.size === null) {
            return "[...]" + this.elementType.toString();
        }
        return "[" + this.size.toString() + "]" + this.elementType.toString();
    }
}
exports.ArrayType = ArrayType;
//# sourceMappingURL=ArrayType.js.map