"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
class ComponentType extends Type_1.Type {
    constructor() {
        super();
        this.implements = [];
        /**
         * Fields of the component, ordered by their appearance in the code
         */
        this.fields = [];
        /**
         * Member methods indexed by their name
         */
        this.methods = new Map();
    }
    field(name, ownFieldsOnly = false) {
        for (let f of this.fields) {
            if (f.name == name) {
                return f;
            }
        }
        //        if (!ownFieldsOnly && this.extends && this.extends instanceof StructType) {
        //            return this.extends.field(name)
        //        }
        return null;
    }
    method(name) {
        if (this.methods.has(name)) {
            return this.methods.get(name);
        }
        //        if (this.extends && this.extends instanceof StructType) {
        //            return this.extends.method(name)
        //        }
        return null;
    }
    toString() {
        return "component " + this.name + "." + this.pkg.pkgPath + ";";
    }
    toTypeCodeString() {
        return "component " + this.name + "." + this.pkg.pkgPath + ";";
    }
    getAllMethodsAndFields(map) {
        if (!map) {
            map = new Map();
        }
        for (let key of this.methods.keys()) {
            map.set(key, this.methods.get(key));
        }
        for (let f of this.fields) {
            map.set(f.name, f);
        }
        return map;
    }
}
exports.ComponentType = ComponentType;
//# sourceMappingURL=ComponentType.js.map