"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
class MapType extends Type_1.Type {
    constructor(keyType, valueType) {
        super();
        this.keyType = keyType;
        this.valueType = valueType;
    }
    toString() {
        if (this.name) {
            return this.name;
        }
        return "map[" + this.keyType.toString() + "]" + this.valueType.toString();
    }
    toTypeCodeString() {
        if (this.name) {
            return this.name;
        }
        return "map[" + this.keyType.toTypeCodeString() + "]" + this.valueType.toTypeCodeString();
    }
}
exports.MapType = MapType;
//# sourceMappingURL=MapType.js.map