"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
/**
 * ObjectLiteralTypes are created while parsing and are then unified.
 * They are gone after type checking.
 */
class ObjectLiteralType extends Type_1.Type {
    constructor(types) {
        super();
        this.types = types;
    }
    toTypeCodeString() {
        throw "Implementation error";
    }
    toString() {
        let name = "literal{";
        for (let t of this.types.keys()) {
            if (name == "literal{") {
                name += t + ": " + this.types.get(t).toString();
            }
            else {
                name += "," + t + ": " + this.types.get(t).toString();
            }
        }
        name += "}";
        return name;
    }
}
exports.ObjectLiteralType = ObjectLiteralType;
//# sourceMappingURL=ObjectLiteralType.js.map