"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helper_1 = require("../typecheck/helper");
const Type_1 = require("./Type");
const StringLiteralType_1 = require("./StringLiteralType");
class OrType extends Type_1.Type {
    constructor(types) {
        super();
        if (types) {
            this.types = types;
        }
        else {
            this.types = [];
        }
    }
    toString() {
        if (this.name) {
            return this.name;
        }
        let name = "";
        for (let v of this.types) {
            if (name == "") {
                name += v.toString();
            }
            else {
                name += " | " + v.toString();
            }
        }
        return name;
    }
    // TODO: Scoping
    toTypeCodeString() {
        return this.toString();
    }
    stringsOnly() {
        for (let t of this.types) {
            if (!(t instanceof StringLiteralType_1.StringLiteralType)) {
                return false;
            }
        }
        return true;
    }
    isPureValue() {
        for (let t of this.types) {
            if (!helper_1.isPureValue(t)) {
                return false;
            }
        }
        return true;
    }
}
exports.OrType = OrType;
//# sourceMappingURL=OrType.js.map