"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
const MapType_1 = require("./MapType");
const RestrictedType_1 = require("./RestrictedType");
const errors_1 = require("../errors");
class PointerType extends Type_1.Type {
    constructor(elementType, mode) {
        super();
        this.elementType = elementType;
        this.mode = mode;
    }
    toString() {
        if (this.name) {
            return this.name;
        }
        let op = '';
        if (this.mode == "local_reference") {
            op = "&";
        }
        else if (this.mode == "reference") {
            op = "~";
        }
        else if (this.mode == "unique") {
            op = "^";
        }
        else if (this.mode == "strong") {
            if (!(RestrictedType_1.RestrictedType.strip(this.elementType) instanceof MapType_1.MapType)) {
                op = "*";
            }
        }
        else {
            throw new errors_1.ImplementationError();
        }
        if (this.elementType instanceof RestrictedType_1.RestrictedType) {
            return this.elementType.toString(true) + op + this.elementType.elementType.toString();
        }
        return op + this.elementType.toString();
    }
    toTypeCodeString() {
        if (this.name) {
            return this.name;
        }
        let op = '';
        if (this.mode == "local_reference") {
            op = "&";
        }
        else if (this.mode == "reference") {
            op = "~";
        }
        else if (this.mode == "unique") {
            op = "^";
        }
        else if (this.mode == "strong") {
            if (!(RestrictedType_1.RestrictedType.strip(this.elementType) instanceof MapType_1.MapType)) {
                op = "*";
            }
        }
        else {
            throw new errors_1.ImplementationError();
        }
        return op + this.elementType.toTypeCodeString();
    }
}
exports.PointerType = PointerType;
//# sourceMappingURL=PointerType.js.map