"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("../errors");
const Type_1 = require("./Type");
// Implements restrictions
class RestrictedType extends Type_1.Type {
    constructor(elementType, r = null) {
        super();
        this.elementType = elementType;
        if (r) {
            this.isConst = r.isConst;
        }
        else {
            this.isConst = false;
        }
    }
    static strip(t) {
        if (t instanceof RestrictedType) {
            return t.elementType;
        }
        return t;
    }
    toString(omitElement) {
        if (!this.elementType) {
            throw new errors_1.ImplementationError('elementType not set');
        }
        if (this.name) {
            return this.name;
        }
        let str = "";
        if (this.isConst && this.elementType.name != "string") {
            str += "const ";
        }
        if (omitElement) {
            return str;
        }
        return str + this.elementType.toString();
    }
    toTypeCodeString() {
        if (!this.elementType) {
            throw new errors_1.ImplementationError('elementType not set');
        }
        let str = "";
        if (this.isConst) {
            str += "const ";
        }
        return str + this.elementType.toString();
    }
}
exports.RestrictedType = RestrictedType;
//# sourceMappingURL=RestrictedType.js.map