"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FunctionType_1 = require("./FunctionType");
/**
 * TemplateFunctionType is the instance of a TemplateType.
 */
class TemplateFunctionType extends FunctionType_1.FunctionType {
    constructor() {
        super();
        this.templateParameterTypes = [];
    }
    toString() {
        if (this.name) {
            if (this.objectType) {
                return this.objectType.toString() + "." + this.name;
            }
            return this.name;
        }
        let name = "<";
        for (let i = 0; i < this.templateParameterTypes.length; i++) {
            if (i != 0) {
                name += ",";
            }
            name += this.templateParameterTypes[i];
            if (this.templateParameterTypes[i]) {
                name += " is " + this.templateParameterTypes[i].toString();
            }
        }
        name += ">(";
        let j = 0;
        for (let p of this.parameters) {
            if (j != 0) {
                name += ",";
            }
            if (p.ellipsis) {
                name += "...";
            }
            name += p.type.toString();
            j++;
        }
        name += ") => " + this.returnType.toString();
        return name;
    }
}
exports.TemplateFunctionType = TemplateFunctionType;
//# sourceMappingURL=TemplateFunctionType.js.map