"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const InterfaceType_1 = require("./InterfaceType");
/**
 * TemplateInterfaceType is the instance of a TemplateType.
 */
class TemplateInterfaceType extends InterfaceType_1.InterfaceType {
    constructor() {
        super();
        this.templateParameterTypes = [];
    }
    toString() {
        let g = "<";
        let lst = [];
        for (let s of this.templateParameterTypes) {
            lst.push(s.toString());
        }
        g += lst.join(",");
        g += ">";
        if (this.name) {
            return this.name + g;
        }
        let str = "interface" + g + "{";
        let m = [];
        for (let mt of this.methods.values()) {
            m.push(mt.toString());
        }
        str += m.join(";");
        str += "}";
        return str;
    }
}
exports.TemplateInterfaceType = TemplateInterfaceType;
//# sourceMappingURL=TemplateInterfaceType.js.map