"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const StructType_1 = require("./StructType");
/**
 * TemplateStructType is the instance of a TemplateType.
 */
class TemplateStructType extends StructType_1.StructType {
    constructor() {
        super();
        this.templateParameterTypes = [];
    }
    toString() {
        let g = "<";
        let lst = [];
        for (let s of this.templateParameterTypes) {
            lst.push(s.toString());
        }
        g += lst.join(",");
        g += ">";
        if (this.name) {
            return this.name + g;
        }
        let str = "struct" + g + "{";
        str += this.fields.join(",");
        str += "}";
        return str;
    }
}
exports.TemplateStructType = TemplateStructType;
//# sourceMappingURL=TemplateStructType.js.map