"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
const errors_1 = require("../errors");
/**
 * TupleLiteralTypes are created while parsing and are then unified.
 * They are gone after type checking.
 */
class TupleLiteralType extends Type_1.Type {
    constructor(types) {
        super();
        this.types = types;
    }
    toString() {
        let name = "literal(";
        for (let t of this.types) {
            if (name == "literal(") {
                name += t.toString();
            }
            else {
                name += "," + t.toString();
            }
        }
        name += ")";
        return name;
    }
    toTypeCodeString() {
        throw new errors_1.ImplementationError();
    }
}
exports.TupleLiteralType = TupleLiteralType;
//# sourceMappingURL=TupleLiteralType.js.map