"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("./Type");
class TupleType extends Type_1.Type {
    constructor(types) {
        super();
        this.types = types;
    }
    toString() {
        if (this.name) {
            return this.name;
        }
        let name = "(";
        for (let t of this.types) {
            if (name == "(") {
                name += t.toString();
            }
            else {
                name += "," + t.toString();
            }
        }
        name += ")";
        return name;
    }
    toTypeCodeString() {
        let name = "(";
        for (let t of this.types) {
            if (name == "(") {
                name += t.toString();
            }
            else {
                name += "," + t.toString();
            }
        }
        name += ")";
        return name;
    }
}
exports.TupleType = TupleType;
//# sourceMappingURL=TupleType.js.map